.686p                     ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive
.xmm

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data
   pbcd      dt ?
             db  6 dup (0)
   szFirst9  db 32 dup (0)
   szLast9   db 32 dup (0)

   ii        dd 1,2,4,8,16,32,64,128,256,512,0,0,0,0,0,0 ; 1022 for pandigital

   aa        real10   0.0
             db    6  dup (0)
   bb        real10   1.0
             db    6  dup (0)
   zz        real10   0.0
             db    6  dup (0)
   yy        real10   1.0
             db    6  dup (0)
   a8        real10   0.0
             db    6  dup (0)
   tw        real10   1.0e20
             db    6  dup (0)
   te        real10   10.0
             db    6  dup (0)
   hu        real10   100.0
             db    6  dup (0)
   ei        real10   1.0e18
             db    6  dup (0)
   ni        real10   1.0e9
             db    6  dup (0)

   fib       dd 0
   i         dd 0

   bothends  dd 0
   first9    dd 0
   last9     dd 0
   szFirst9zero  dd 0

   szFirst9ti  db "The first 9 digits of the kth fibonacci number are ", 0

   szLast9ti   db "The last  9 digits of the kth fibonacci number are ", 0

   szkth       db "A k with first9 and last9 pandigital is "
   szAns       db 64 dup (0)

   szFmt       db "%lu",0

; 


.code

start:
   finit

   fldz
   fstp  aa
   fldz
   fstp  zz
   mov   fib, 0

   fld1
   fstp  bb
   fld1
   fstp  yy
   inc   fib

   mov   i, 0

   .repeat
      fld  bb
      fld  aa
      faddp st(1), st     ; st1 = st1 + st  pop st
      fstp aa

      fld  yy
      fld  zz
      faddp st(1), st     ; st1 = st1 + st  pop st
      fstp zz

;==========================
      fld   zz
      fbstp pbcd          ; store Packed BCD 5 bytes lo -> hi, within a byte hi, lo nibble first, second
      fwait

      mov   eax, 0
      mov   ecx, 4        ; 5 packed bytes -> 10 unpacked bytes
      mov   edx, 0
@@:
      mov   al, byte ptr pbcd[ecx]
      shl   eax, 4
      mov   szLast9[edx+0], ah
      mov   ah,  0
      shr   eax, 4
      mov   szLast9[edx+1], al
      inc   edx
      inc   edx
      jecxz @F
      dec   ecx
      jmp   @B
@@:
      mov   szLast9, 10   ; put a 10 in the 0th byte, it has no effect on pandigital test

      mov   ecx, 9        ; 10 chars +0 to +9 first is : which has a value of 0  pandigital test
      mov   esi, offset szLast9
      mov   edi, offset ii
      mov   edx, 0
@@:
      movzx eax, byte ptr [esi + ecx]
      mov   eax, [edi + eax*4]
      or    edx, eax
      jecxz @F
      dec   ecx
      jmp   @B
@@:
      mov   eax, 0        ; 0 is false
      xor   edx, 1022     ; if becomes 0, matches pandigital
      jnz   @F
      inc   eax           ; 1 is true
@@:
      mov   last9, eax
;==========================

;==========================
      cmp last9, 1        ; 1
      jne skipfirst9
                          ; condition real10 so whole part is 18 or less digits OR NAN is stored
 ;      repeat
 ;       if aa >= 1e18
 ;         aa := aa / 10.0

      fld  aa
      fstp a8
@@:
      fld  a8
      fld  ei
      fcompp            ;  if a8 >= ei
      fstsw ax                              
      sahf
      ja   @F           ;  no jump past  
         fld    a8       ;    a8
         fld    te       ;    te
         fdivp  st(1),st ;    a8 / te
         fstp   a8       ;    a8 = 
         fwait
      jmp @B
@@:
;=============
      fld   a8
      fbstp pbcd          ; store Packed BCD 9 bytes lo -> hi, within a byte hi, lo nibble first, second
      fwait

      mov   eax, 0
      mov   ecx, 8        ; 9 packed bytes -> 18 unpacked bytes
      mov   edx, 0
@@:
      mov   al, byte ptr pbcd[ecx]
      shl   eax, 4
      mov   szFirst9[edx+0], ah
      mov   ah,  0
      shr   eax, 4
      mov   szFirst9[edx+1], al
      inc   edx
      inc   edx
      jecxz @F
      dec   ecx
      jmp   @B
@@:

      mov   ecx, 8        ; 9 chars +0 to +8
      mov   esi, offset szFirst9
      mov   edi, offset ii
      mov   edx, 0
@@:
      movzx eax, byte ptr [esi + ecx]
      mov   eax, [edi + eax*4]
      or    edx, eax
      jecxz @F
      dec   ecx
      jmp   @B
@@:
      mov   eax, 0        ; 0 is false
      xor   edx, 1022     ; if becomes 0, matches pandigital
      jnz   @F
      inc   eax           ; 1 is true
@@:
      mov   first9, eax
;==========================

skipfirst9:

      fld  bb  ; swap aa bb  pop both
      fld  aa
      fstp bb
      fstp aa

      fld  yy  ; swap zz yy  pop both
      fld  zz
      fstp yy
      fstp zz

      fld  zz       ; if zz >= ni
      fld  ni
      fcompp
      fstsw ax
      sahf
      ja @F         ; no  skip
         fld   zz   ; yes zz - ni
         fld   ni
         fsubp st(1),st(0)
         fstp  zz
         fwait
@@:
      fld  yy       ; if yy >= ni
      fld  ni
      fcompp
      fstsw ax
      sahf
      ja @F         ; no  skip
         fld   yy   ; yes yy - ni
         fld   ni
         fsubp st(1),st(0)
         fstp  yy
         fwait
@@:
      inc  i
      .if i >= 5
         mov  i, 0
         fld  aa
         fld  tw
         fcompp            ;  if aa > tw
         fstsw ax                              
         sahf
         jnb  @F           ;  no jump past  
           fld    aa       ;    aa
           fld    hu       ;    hu
           fdivp  st(1),st ;    aa / hu
           fstp   aa       ;    aa = 
           fwait

           fld    bb       ;    bb
           fld    hu       ;    hu
           fdivp  st(1),st ;    bb / hu
           fstp   bb       ;    bb =
           fwait
      .endif
@@:
      inc fib
   .until ((last9 == 1) && (first9 == 1))





   fld  bb  ; swap aa bb  pop both   reverse last swap
   fld  aa
   fstp bb
   fstp aa

   fld  yy  ; swap zz yy  pop both   reverse last swap
   fld  zz
   fstp yy
   fstp zz

@@:
   fld  aa
   fld  ei           ;  ei se
   fcompp            ;  if aa > ei
   fstsw ax                              
   sahf
   jnb  @F           ;  no jump past  
     fld  aa         ;  aa
     fld  te         ;  10.0
     fdivp st(1),st  ;  a / te
     fstp aa         ;  aa :=
     fwait
     jmp @B
@@:




   fld   aa
   fbstp pbcd       ; store Packed BCD 9 bytes lo -> hi, within a byte hi, lo nibble first, second
   fwait

   mov eax, 0
   mov ecx, 8       ; 9 packed bytes -> 18 unpacked bytes
   mov edx, 0
@@:
   mov al, byte ptr pbcd[ecx]
   shl eax, 4
 ;    or  ah,  30h
   mov szFirst9[edx+0], ah
   mov ah,  0
   shr eax, 4
 ;    or  al,  30h
   mov szFirst9[edx+1], al
   inc edx
   inc edx
   jecxz @F
   dec   ecx
   jmp   @B
@@:
   mov   ecx, 8                ; 9 chars +0 to +8   pandigital test
   mov   esi, offset szFirst9
   mov   edi, offset ii
   mov   edx, 0
@@:
   movzx eax, byte ptr [esi + ecx]
   mov   eax, [edi + eax*4]
   or    edx, eax
   jecxz @F
   dec   ecx
   jmp   @B
@@:
   mov   eax, 0        ; 0 is false
   xor   edx, 1022     ; if becomes 0, matches pandigital
   jnz   @F
   inc   eax           ; 1 is true
@@:
   mov first9, eax

   mov ecx, 30303030h  ; turn into szascii string
   mov eax, 0
   or  dword ptr szFirst9[eax*4], ecx
   inc eax
   or  dword ptr szFirst9[eax*4], ecx
   inc eax
   or            szFirst9[eax*4], cl
   mov           szFirst9[eax*4+1], 0

 ;    mov dword ptr szFirst9+9, "F   "
 ;    .if first9 == 1
 ;       mov dword ptr szFirst9+9, "T   "
 ;    .endif
 ;    mov szFirst9+13,0






   fld   zz
   fbstp pbcd       ; store Packed BCD 9 bytes lo -> hi, within a byte hi, lo nibble first, second
   fwait

   mov eax, 0
   mov ecx, 4       ; 5 packed bytes -> 10 unpacked bytes
   mov edx, 0
@@:
   mov al, byte ptr pbcd[ecx]
   shl eax, 4
 ;    or  ah,  30h
   mov szLast9[edx+0], ah
   mov ah,  0
   shr eax, 4
 ;    or  al,  30h
   mov szLast9[edx+1], al
   inc edx
   inc edx
   jecxz @F
   dec   ecx
   jmp   @B
@@:
   mov szLast9, 10  ; put a 10 in the 0th byte, it has no effect on pandigital test

   mov   ecx, 9                ; 10 chars +0 to +9 first is : which has a value of 0  pandigital test
   mov   esi, offset szLast9
   mov   edi, offset ii
   mov   edx, 0
@@:
   movzx eax, byte ptr [esi + ecx]
   mov   eax, [edi + eax*4]
   or    edx, eax
   jecxz @F
   dec   ecx
   jmp   @B
@@:
   mov   eax, 0        ; 0 is false
   xor   edx, 1022     ; if becomes 0, matches pandigital
   jnz   @F
   inc   eax           ; 1 is true
@@:
   mov last9, eax

   mov ecx, 30303030h  ; turn into szascii string
   mov eax, 0
   or  dword ptr szLast9[eax*4], ecx
   inc eax
   or  dword ptr szLast9[eax*4], ecx
   inc eax
   or   word ptr szLast9[eax*4], cx
   mov szLast9, " "

 ;    mov dword ptr szLast9+10, "F   "
 ;    .if last9 == 1
 ;       mov dword ptr szLast9+10, "T   "
 ;    .endif
 ;    mov szLast9+14,0







   invoke MessageBox,NULL,ADDR szFirst9,ADDR szFirst9ti,MB_OK

   invoke MessageBox,NULL,ADDR szLast9, ADDR szLast9ti,MB_OK

   mov  edx, fib
   invoke wsprintf, ADDR szAns, ADDR szFmt, edx

   invoke MessageBox,NULL,ADDR szAns,   ADDR szkth,MB_OK

   invoke  ExitProcess, 0

end start